#Include "form.bi"
#Include "button.bi"
#Include "listview.bi"
#Include "application.bi"

#Inclib "form"
#inclib "button"
#inclib "listview"
#inclib "application"

AllowRunTimeCreation=1

using ApplicationObject


dim as hwnd hForm=createwindowex(ws_ex_appwindow,_
                                 "TForm",_
                                 "Form",_
                                 ws_overlappedwindow or ws_clipchildren or ws_clipsiblings,_
                                 0,_
                                 0,_
                                 400,_
                                 300,_
                                 0,_
                                 0,_
                                 GetModuleHandle(0),_
                                 0)
dim as hwnd hButton=createwindowex(0,_
                                 "TButton",_
                                 "Button",_
                                 ws_child or ws_visible,_
                                 10,_
                                 10,_
                                 75,_
                                 35,_
                                 hForm,_
                                 0,_
                                 GetModuleHandle(0),_
                                 0) 
dim as hwnd hListView=createwindowex(ws_ex_clientedge,_
                                 "TListView",_
                                 "",_
                                 ws_child or ws_visible,_
                                 10,_
                                 50,_
                                 200,_
                                 200,_
                                 hForm,_
                                 0,_
                                 GetModuleHandle(0),_
                                 0)

sub FormClose(sender as TForm,byref action as integer)
    if MessageBox(sender.handle,"Quit ?","Application",mb_yesno)=idno then
        action=0
    end if
end sub

sub ButtonClick(sender as TButton)
    MessageBox(sender.handle,"Button Click","TButton",0)
end sub

dim as TForm ptr Form=GetForm(hForm)
with *Form
    .Caption="Run time creation"
    .Color=255
    .Center=1
    .Visible=1
    .OnClose=@FormClose
end with

dim as TButton ptr Button=GetButton(hButton)
with *Button
    .Caption="ok"
    .onClick=@ButtonClick
end with

dim as TListView ptr ListView=GetListView(hListView)
with *ListView
    .ViewStyle=2
    .AddColumn "1",100
    .AddColumn "2",95
    .AddItem "item_1"
    .AddItem "item_2"
    .AddSubItem 0,"subitem_1"
    .AddSubItem 1,"subitem_2"
end with

'''Main Loop
Application.Run

